//+------------------------------------------------------------------+
#property copyright "Vladimir Khlistov"
#property link      "http://cmillion.narod.ru"
#property show_inputs
#include <WinUser32.mqh>
//+------------------------------------------------------------------+
extern int   Magic       = 0;   //     0- 
extern bool  MagicAll    = true;// true -  
extern int   Profit      = 0;   //      Profit
extern int   TipOrder    = 0;   //(0) -     (1) - Buy     (-1) - Sell
extern bool  SymbolAll   = false;// true -      false -  
extern bool  DeleteOrders= true;// true -      false -  
extern int   attempts   = 10;    //-  
int   slippage    = 5;
int nn;
//+------------------------------------------------------------------+
int start()
{  
   Comment("  CloseAllOrders ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS));
   if (Digits==5 || Digits==3) slippage=30;
   bool error=true;
   int ,DIGITS,OT,Ticket;
   string txt;
   double ASK,BID,POINT;
   if (!MagicAll)  txt=StringConcatenate(txt,"C    Magic=",Magic);
   else  txt=StringConcatenate(txt,"C   ");
   Comment("");
   int ret=MessageBox("   ()      ()",
       txt, MB_YESNOCANCEL|MB_TOPMOST);
   if (ret==IDCANCEL)return;
   while(true)
   {
      for (int j = OrdersTotal()-1; j >= 0; j--)
      {
         if (OrderSelect(j, SELECT_BY_POS))
         {
            if ((OrderSymbol() == Symbol()||SymbolAll) && (OrderMagicNumber() == Magic || MagicAll))
            {
               DIGITS = MarketInfo(OrderSymbol(),MODE_DIGITS);
               ASK = NormalizeDouble(MarketInfo(OrderSymbol(),MODE_ASK),DIGITS);
               BID = NormalizeDouble(MarketInfo(OrderSymbol(),MODE_BID),DIGITS);
               POINT = MarketInfo(OrderSymbol(),MODE_POINT);
               OT = OrderType();
               Ticket=OrderTicket();
               if (OT==OP_BUY && (TipOrder == 1||TipOrder ==0)) 
               {
                  if (ret==IDNO && Profit > (BID-OrderOpenPrice())/POINT) continue;
                  error=OrderClose(Ticket,OrderLots(),BID,slippage,Red);
                  if (error) Alert("  N ",Ticket,"   ",OrderProfit(),
                                     "     ",TimeToStr(TimeCurrent(),TIME_SECONDS));
               }
               if (OT==OP_SELL && (TipOrder ==-1||TipOrder ==0)) 
               {
                  if (ret==IDNO && Profit > (OrderOpenPrice()-ASK)/POINT) continue;
                  error=OrderClose(Ticket,OrderLots(),ASK,slippage,Red);
                  if (error) Alert("  N ",Ticket,"   ",OrderProfit(),
                                     "     ",TimeToStr(TimeCurrent(),TIME_SECONDS));
               }
               if (OT>1 && DeleteOrders) 
                  if (OrderDelete(Ticket))
                     Comment(" ",Ticket,"   ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS));
                  else
                     Comment(" ",Ticket,"   ",GetLastError());
               
               if (!error) 
               {
                   = GetLastError();
                  if (<2) continue;
                  if (==129) 
                  {  Comment("  ",TimeToStr(TimeCurrent(),TIME_SECONDS));
                     Sleep(5000);
                     RefreshRates();
                     continue;
                  }
                  if (==146) 
                  {
                     int ret1=MessageBox("  "," ", 
                         MB_RETRYCANCEL|MB_TOPMOST|MB_ICONWARNING);
                     if (ret1==IDCANCEL)return;
                     j++;
                     if (IsTradeContextBusy()) Sleep(2000);
                     continue;
                  }
                  Comment(" ",,"   N ",Ticket,"     ",TimeToStr(TimeCurrent(),TIME_SECONDS));
               }
            }
         }
      }
      int n=0;
      for (j = 0; j < OrdersTotal(); j++)
      {
         if (OrderSelect(j, SELECT_BY_POS))
         {
            if ((OrderSymbol() == Symbol()||SymbolAll) && (OrderMagicNumber() == Magic || MagicAll))
            {
               DIGITS = MarketInfo(OrderSymbol(),MODE_DIGITS);
               ASK = NormalizeDouble(MarketInfo(OrderSymbol(),MODE_ASK),DIGITS);
               BID = NormalizeDouble(MarketInfo(OrderSymbol(),MODE_BID),DIGITS);
               POINT = MarketInfo(OrderSymbol(),MODE_POINT);
               if (OrderType()==OP_BUY  && (TipOrder == 1||TipOrder ==0))
               {
                  if (ret==IDNO && Profit > (BID-OrderOpenPrice())/POINT) continue;
                  n++;
               }
               if (OrderType()==OP_SELL && (TipOrder ==-1||TipOrder ==0))
               {
                  if (ret==IDNO && Profit > (OrderOpenPrice()-ASK)/POINT) continue;
                  n++;
               }
               if (OT>1 && DeleteOrders) n++;
            }
         }  
      }
      if (n==0) break;
      nn++;
      if (nn>attempts) {Comment("    ,   ",n);break;}
      Sleep(1000);
      RefreshRates();
   }
   return(0);
}
//+------------------------------------------------------------------+

